//related_search_queries.js
(function()
{
    var safe_SW_getBoolPref = function(name)
    {
        try
        {
            return SW_getBoolPref(name);
        }
        catch(err)
        {
            return null;
        }
    };

    var getBoolPref = function(pref_name, callback)
    {
        callback(safe_SW_getBoolPref("extensions.smarterwiki." + pref_name));
    };
    if(window.chrome && window.chrome.extension) // detect chrome
    {
        var get_localStorage = function(key, callback) //only used for Chrome
        {    
            chrome.extension.sendRequest({"msg_type": "get_localStorage", "key": key}, function(response)
            {
                if(callback)
                {
                    callback(response.value);
                }
            });
        };

        getBoolPref = function(pref_name, callback)
        {
            get_localStorage("pref." + pref_name, function(str)
            {
                callback(str == "true");
            });
        };
        
        SW_$ = $;
        SW_LOG = function(){};
        $.get = function(url, data, callback, type)
        {
            chrome.extension.sendRequest({"msg_type": "$.get", "url": url, "data": data, "type": type}, function(response)
            {
                if(callback)
                {
                    callback(response.data, response.textStatus);
                }
            });            
        };
    }    
    
    var showOptions = function()
    {
        if(window.chrome && window.chrome.extension)
        {
            chrome.extension.sendRequest({"msg_type": "show_options"});
        }
        else
        {
            var wind = SW_showOptions();
            setTimeout(function()
            {
                wind.document.getElementById("smarterwikiOptions").showPane(wind.document.getElementById("SmarterWikiOptions_search_results"));
            }, 150); //must wait for init
        }
    };

    var confirm_disable = window.confirm_disable || "Are you sure you want to disable this?\n\nTo re-enable, go to Tools -> SmarterFox";
    var disable_str = window.disable_label || "disable";

    var get_log_msg_url = function(msg)
    {
        msg["rand"] = parseInt(Math.random() * 1000000000);
        var params = [];
        for(var k in msg)
        {
            params.push(encodeURIComponent(k) + "=" + encodeURIComponent(msg[k]));
        }
        /*
        if("https:" == document.location.protocol)
        {
            return "https://ssl.msgs.smarterfox.com/log_msg?" + params.join("&");
        }
        */
        return "http://msgs.smarterfox.com/log_msg?" + params.join("&");
    };
    

    var log_msg_async = function(msg, callback)
    {
        var $ting = $('<img style="display: none;" />');
        if(callback)
        {
            $ting.load(callback);
        }
        $ting.attr("src", get_log_msg_url(msg));
        return $ting;
    };

    var track_click = function($a, msg)
    {
        $a.mouseup(function(event)
        {
            var original_href = $a.attr("href");
            msg["redirect_to"] = original_href;
            $a.attr("href", get_log_msg_url(msg));

            setTimeout(function()
            {
                $a.attr("href", original_href);
            }, 10);
        });
    };   
    
    function escapeHTMLEncode(str) 
    {
        var div = document.createElement('div');
        var text = document.createTextNode(str);
        div.appendChild(text);
        return div.innerHTML;
    }

    var truncate_string = function(s, len)
    {
        if(s.length > len)
        {
            return s.substring(0, len) + "...";
        }
        return s;
    };



    var getSearchResultsURL = function(url, terms)
    {
        var language = navigator.language ? navigator.language : navigator.userLanguage;
        var url = url.replace(/{searchTerms}/g, encodeURIComponent(terms));
        url = url.replace(/{language}/g, language);
        return url;
    };

    var searchAmazonURL = "http://www.amazon.com/s?ie=UTF8&index=blended&field-keywords={searchTerms}&tag=smtfx1-20";
    var searchOneRiotURL = "http://www.oneriot.com/search?p=smarterfox&ssrc=smarterfox_popup_bubble&spid=8493c8f1-0b5b-4116-99fd-f0bcb0a3b602&q={searchTerms}";


    var add_oneriot_results_to_google = function(queryTerms)
    {
        var has_news_result = false;
        $("#res ol li h3 a").each(function()
        {
            if(/(^| )(n|N)ews( |$)/.test($(this).text())) {
                has_news_result = true;
                return false;
            }
        });
        if(queryTerms.length < 5 || !/^en/.test(navigator.language) || !has_news_result)
        {
            return;
        }
        SW_$.get("http://api3.smarterfox.com/api/search_oneriot", {"q": queryTerms, "limit": 1}, function(data)
        {
            var search_result = data["resultList"][0];
            var total_shares = 0;
            for(var i = 0; i < search_result["sharesList"].length; i++)
            {
                total_shares += search_result["sharesList"][i]["total"];
            }
            if(total_shares >= 45)// && (new Date() - search_result["firstShare"]["time"] * 1000 > 5 * 24 * 60 * 60 * 1000)
            {
                var displayed_url = new RegExp("https?://(.*)$").exec(search_result["displayUrl"])[1];
                displayed_url = truncate_string(displayed_url, 65);

                var $related_search_results = jQuery('' + 
'<li id="related-oneriot-search-results-google" class="related-search-results related-oneriot-search-results related-search-results-google">' + 
'    <h3 class="related-search-results-title">' + 
'        <span class="related-search-results-title-link">' + 
'            <a class="related-search-results-title-label" href="' + getSearchResultsURL(searchOneRiotURL, queryTerms) + '">' + 
'                Realtime results for <em>' + escapeHTMLEncode(queryTerms) + '</em> from OneRiot</a>' + 
'            <a class="related-search-results-show-options" href="#"><img class="related-search-results-title-icon" src="http://static.smarterfox.com/media/img/smarterfox-logo.png" /></a>' + 
'        </span>' + 
'    </h3>' + 
'    <div class="related-search-results-result">' + 
'        <div class="related-search-results-result-preview">' + 
'        </div>' + 
'        <div class="related-search-results-result-details">' + 
'            <div class="related-search-results-result-title"><a class="related-search-results-result-title-link related-search-results-oneriot-result-title-link" href="' + search_result["displayUrl"] + '">' + 
                 search_result["title"] + 
'            </a></div>' + 
'            <div class="related-search-results-result-snippet">' + 
                 search_result["snippet"] + 
'            </div>' + 
'            <div class="related-search-results-result-url">' + 
'                <cite>' + 
                     displayed_url + 
'                </cite>' + 
'            </div>' +
'        </div>' + 
'    </div>' + 
'    <div class="related-search-results-bottom">' + 
//'        <div class="related-search-results-remove">' +     
//'        </div>' +     
'        <div class="related-search-results-more">' +     
'            <a class="related-search-results-more-results-link" href="' + getSearchResultsURL(searchOneRiotURL, queryTerms) + '">' + 
'                <img src="http://static.smarterfox.com/media/popup_bubble/oneriot-favicon.ico" />' + 
'                <span class="related-search-results-more-results-label">' + data["totalResults"] + ' more results &#x00bb;</span>' + 
'            </a>' +     
'        </div>' +     
'    </div>' +     
'</li>');
                var google_results = $("#res ol li");
                $(google_results[0]).before($related_search_results);
                $related_search_results.find(".related-search-results-result-title-link.related-search-results-oneriot-result-title-link")
                        .mouseup(function(event)
                {
                    var $a = $(this);
                    var original_href = $a.attr("href");
                    var msg = {
                        "name": "related_search_result_clicked", 
                        "source": "Google Search", 
                        "type": "OneRiot", 
                        "queryTerms": queryTerms,
                        "action": "result #0 clicked"
                        };
                    msg["redirect_to"] = search_result["redirectUrl"];
                    $a.attr("href", get_log_msg_url(msg));

                    setTimeout(function()
                    {
                        $a.attr("href", original_href);
                    }, 10);
                });
                track_click($related_search_results.find(".related-search-results-title-label"), {
                    "name": "related_search_result_clicked", 
                    "source": "Google Search", 
                    "type": "OneRiot", 
                    "queryTerms": queryTerms, 
                    "action": "re-searched"});

                $related_search_results.find(".related-search-results-show-options").click(function()
                {
                    showOptions();
                });
            }
        }, "json");
    };
    
    var add_amazon_results_to_google = function(queryTerms)
    {
        add_amazon_results(queryTerms, "google", "#res ol li h3 a", function($related_search_results)
        {
            var google_results = $("#res ol li");
            $(google_results[0]).before($related_search_results);
        }, "em");
    };

    var add_amazon_results_to_yahoo = function(queryTerms)
    {
        add_amazon_results(queryTerms, "yahoo", "#web ol li h3 a", function($related_search_results)
        {
            var yahoo_results = $("#web ol li");
            $(yahoo_results[0]).before($related_search_results);
        }, "b");
    };

    var add_amazon_results_to_bing = function(queryTerms)
    {
        add_amazon_results(queryTerms, "bing", "#results ul li h3 a, .sr_dcard a", function($related_search_results)
        {
            if(queryTerms == "Amazon" || queryTerms == "amazon")
            {
                $(".sr_dcard").before($related_search_results);
            }
            else
            {
                var bing_results = $("#results ul li");
                $(bing_results[0]).before($related_search_results);
            }
        }, "strong");
    };

    var add_amazon_results = function(queryTerms, search_engine_name, search_result_a_patt, add_div, bold_tag)
    {
        var has_amazon_result = false;
        $(search_result_a_patt).each(function()
        {
            if(/www\.amazon\.com/.test($(this).attr("href"))) {
                has_amazon_result = true;
                return false;
            }
        });//new RegExp("^http://www.amazon.com/$"), "http://www.amazon.com/?tag=smtfx1-20"
        if(has_amazon_result)
        {
            var title_url = getSearchResultsURL(searchAmazonURL, queryTerms);
            var title_text = 'Amazon results for <em>' + escapeHTMLEncode(queryTerms) + '</em>';
            if(/(A|a)mazon(.com)?/.test(queryTerms))
            {
                title_url = "http://www.amazon.com/?tag=smtfx1-20";
                title_text = "<"+bold_tag+">Amazon</"+bold_tag+">.com: Online Shopping for Electronics, Apparel, Computers <b>...</b>";
            }

            var $related_search_results = jQuery('' + 
'<li id="related-amazon-search-results-' + search_engine_name + '" class="res related-search-results related-amazon-search-results related-search-results-' + search_engine_name + '">' + 
'    <h3 class="related-search-results-title">' + 
'        <span class="related-search-results-title-link">' + 
'            <a class="related-search-results-title-label" href="' + title_url + '">' + 
'                ' + title_text + '</a>' + 
'            <a class="related-search-results-show-options" href="#"><img class="related-search-results-title-icon" src="http://static.smarterfox.com/media/img/smarterfox-logo.png" /></a>' + 
'        </span>' + 
'    </h3>' + 
'    <div class="related-search-results-results-list">' + 
'    </div>' + 
'    <div class="related-search-results-bottom">' + 
'        <div class="related-search-results-remove">' +     
'        </div>' +     
'    </div>' +     
'</li>');
            
            add_div($related_search_results);
            //$related_search_results.find(".related-search-results-results-list").slideDown("slow");

            track_click($related_search_results.find(".related-search-results-title-label"), {
                "name": "related_search_result_clicked", 
                "source": "Google Search", 
                "type": "Amazon", 
                "queryTerms": queryTerms, 
                "action": "re-searched"});

            $related_search_results.find(".related-search-results-show-options").click(function()
            {
                showOptions();
            });

            SW_$.get("http://api.smarterfox.com/api/search_amazon", {"q": queryTerms}, function(data)
            {
                $related_search_results.find(".related-search-results-bottom").append('' + 
'        <div class="related-search-results-more">' +     
'            <a class="related-search-results-more-results-link" href="' + getSearchResultsURL(searchAmazonURL, queryTerms) + '">' + 
'                <img class="related-search-results-favicon" src="http://www.amazon.com/favicon.ico" />' + 
'                <span class="related-search-results-more-results-label">' + data["TotalResults"] + ' more results &#x00bb;</span>' + 
'            </a>' +     
'        </div>');
                
                for(var x = 0; x < Math.min(data["Items"].length, 4); x++)
                {
                    $related_search_results.find(".related-search-results-results-list").append('' + 
'    <div class="related-search-results-result">' + 
'        <div class="related-search-results-result-preview">' + 
'        </div>' + 
'        <div class="related-search-results-result-details">' + 
'            <img class="related-search-results-result-rating" alt="" src="http://g-ecx.images-amazon.com/images/G/01/x-locale/common/customer-reviews/ratings/stars-' + data["Items"][x]["AverageRating"].replace(".", "-") + '.gif" />' + 
'<span class="related-search-results-result-title"><a class="related-search-results-result-title-link related-search-results-amazon-result-title-link" href="' + data["Items"][x]["DetailPageURL"] + '">' + 
             escapeHTMLEncode(truncate_string(data["Items"][x]["Title"], 65)).replace(new RegExp("("+queryTerms+")", "gi"), '<'+bold_tag+'>$1</'+bold_tag+'>') + '</a></span>' + 
'<span class="related-search-results-result-price">' + 
             data["Items"][x]["FormattedPrice"] + 
'</span>' +
'        </div>' + 
'    </div>');
                }
                $related_search_results.find(".related-search-results-result-title-link").each(function(i)
                {
                    track_click($(this), {
                        "name": "related_search_result_clicked", 
                        "source": search_engine_name + " Search", 
                        "type": "Amazon", 
                        "queryTerms": queryTerms,
                        "action": "result #" + i + " clicked"});
                });
            }, "json");
        }
    };
    

    var add_search_refinements_to_google = function(queryTerms)
    {
        add_search_refinements(queryTerms, "google", function($related_search_results)
        {
            var google_results = $("#res ol li");
            $(google_results[0]).before($related_search_results);
        }, "em");
    };

    var add_search_refinements_to_yahoo = function(queryTerms)
    {
        add_search_refinements(queryTerms, "yahoo", function($related_search_results)
        {
            var yahoo_results = $("#web ol li");
            $(yahoo_results[0]).before($related_search_results);
        }, "b");
    };

    var add_search_refinements_to_bing = function(queryTerms)
    {
        add_search_refinements(queryTerms, "bing", function($related_search_results)
        {
            var bing_results = $("#results ul li");
            $(bing_results[0]).before($related_search_results);
        }, "strong");
    };

    var add_search_refinements = function(queryTerms, search_engine_name, add_div, bold_tag)
    {
        if($("#scTopOfPageRefinementLinks").length == 0)
        {
            var partner = { 
                uiLabel: 'FastestFox Refinements',
                partnerCode: 'fastestfox', 
                authCode: 'knm75903'
            };        
            SW_$.get('http://' + partner.authCode + '.surfcanyon.com/queryReformulation', 
                        {"partner": partner.partnerCode,
                         "authCode": partner.authCode,
                         "q": queryTerms.replace(/ /g, '+')}, function(data)
            {
                if($("#scTopOfPageRefinementLinks").length != 0)
                {
                    return;
                }
                var items = [];
                var total_length = 0;
                $("refinement", data).each(function(i)
                {
                    var query = this.textContent.toLowerCase();
                    var words = queryTerms.replace(/"'\(\),/g, '').replace(/\+/g, ' ').split(' '); //"
                    for (var i = 0; i < words.length; i++) 
                    {
                        var word = words[i];
                        var containsSubstring = function(a, b)
                        {
                            return a.indexOf(b) != -1;
                        };
                        if (!containsSubstring(query.toLowerCase(), word.toLowerCase())) {
                            query = query + ' ' + word;
                        }
                    }
                    total_length += this.textContent.toLowerCase().length;
                    if(total_length > 80)
                    {
                        return false;
                    }
                    items.push('<a href="http://search.surfcanyon.com/search?f=nrl' + i + '&q=' + query.replace(/ /g, '+')
                                + '&partner=' + partner.partnerCode + '">' + this.textContent.toLowerCase() + '</a>');
                                
                });
                if(items.length == 0)
                {
                    return;
                }
                var code = '<div id="scTopOfPageRefinementLinks" style="height: 20px; margin-top: 7px; margin-bottom: 7px;" partner="fastestfox" sctoppos="1">' + 
                '<font size=-1><b>' + items.join(' &nbsp;') + '</b> &nbsp;<font size =-1 color=green>' + partner.uiLabel +
                ' <a id="disableRefinements" style="text-decoration: none; color: green;" title="Disable" href="#">[x]</a></font></font></div>';//
                var $refinements = $(code);
                $refinements.find("#disableRefinements").click(function(event)
                {
                    if(doc.defaultView.confirm(confirm_disable))
                    { 
                        SW_setBoolPref("extensions.smarterwiki.add_search_refinements", false);
                        $refinements.slideUp("normal", function()
                            {
                                $refinements.remove();
                            });
                    }
                    return false;
                });
                add_div($refinements);
                $refinements.find("a").each(function(i)
                {
                    track_click($(this), {
                        "name": "search_refinement_clicked", 
                        "source": search_engine_name + " Search", 
                        "type": "Surf Canyon", 
                        "queryTerms": queryTerms,
                        "action": "result #" + i + " clicked"});
                });
            }, "xml");
        } 
    };

    var add_related_search_results = function(doc)
    {
        var googleURLRegExp = new RegExp("^http://www.google.(?:[^/]*)/(?:search\\?|#)(?:.*&)?q=([^&=]*)(.*)$");
        var match = googleURLRegExp.exec(doc.location.href);
        if(match)
        {
            var queryTerms = decodeURIComponent(match[1]).replace(/\+/g, " ");
            getBoolPref("add_related_search_results_oneriot", function(pref_value)
            {
                if(pref_value) {
                    add_oneriot_results_to_google(queryTerms);
                }
            });
            getBoolPref("add_related_search_results_amazon", function(pref_value)
            {
                if(pref_value) {
                    add_amazon_results_to_google(queryTerms);
                }
            });
            getBoolPref("add_search_refinements", function(pref_value)
            {
                if(pref_value) {
                    add_search_refinements_to_google(queryTerms);
                }
            });
        }

        var yahooURLRegExp = new RegExp("^http://search.yahoo.com/search[^?]*\\?(?:.*&)?p=([^&=]*)(.*)$");
        match = yahooURLRegExp.exec(doc.location.href);
        if(match)
        {
            queryTerms = decodeURIComponent(match[1]).replace(/\+/g, " ");
            getBoolPref("add_related_search_results_amazon", function(pref_value)
            {
                if(pref_value) {
                    add_amazon_results_to_yahoo(queryTerms);
                }
            });
            getBoolPref("add_search_refinements", function(pref_value)
            {
                if(pref_value) {
                    add_search_refinements_to_yahoo(queryTerms);
                }
            });
        }
        
        var bingURLRegExp = new RegExp("^http://www.bing.com/search[^?]*\\?(?:.*&)?q=([^&=]*)(.*)$");
        match = bingURLRegExp.exec(doc.location.href);
        if(match)
        {
            queryTerms = decodeURIComponent(match[1]).replace(/\+/g, " ");
            getBoolPref("add_related_search_results_amazon", function(pref_value)
            {
                if(pref_value) {
                    add_amazon_results_to_bing(queryTerms);
                }
            });
            getBoolPref("add_search_refinements", function(pref_value)
            {
                if(pref_value) {
                    add_search_refinements_to_bing(queryTerms);
                }
            });
        }

        /*
        var baiduURLRegExp = new RegExp("^http://www.baidu.com/s[^?]*\\?(?:.*&)?wd=([^&=]*)(.*)$");
        match = baiduURLRegExp.exec(doc.location.href);
        if(match)
        {
            queryTerms = decodeURIComponent(match[1]).replace(/\+/g, " ");
        }
        */        
     };
    
    
    


    var doc = window.document;
    add_related_search_results(doc);  
    //$(document).ready(function()
    //if(SW_getBoolPref("extensions.smarterwiki.add_related_search_results"))
//});    
}());    
    